//
// C++ Interface: test1
//
// Description:
//
//
// Author: Arne Schmitt <arne@as4m.de>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef _ModelMultiDiagramAdapter_
#define _ModelMultiDiagramAdapter_

#include "modelclient.h"
#include "diagramadapter.h"

class Diagram;
class QStandardItemModel;
class QGridLayout;

class ModelMultiDiagramAdapter : public ModelClient,public DiagramAdapter
{
	Q_OBJECT
	public:
	ModelMultiDiagramAdapter(QWidget *parent=0);

	void setModel(QStandardItemModel *m);
	void setSpalten(const QVector<int> &s);
	void setDiagram(Diagram *d);
	void setTitle(const QString &t);
	Diagram *diagram();
	QStandardItemModel *model();
	QVector<QAction*> actionList();
	
	virtual void saveData(QDataStream& s,int ver=1);
	virtual void loadData(QDataStream& s,int ver=1);

	signals:
	void changeDiagram(DiagramAdapter*mda);

	protected slots:
	virtual void updateDiagram()=0;
	void typAction();

	protected:
	Diagram *td;
	QGridLayout *layout;
	QString _title;
	QVector<int> Spalten;
	QVector<QAction*> actions;
	QAction *aTyp;
	
	protected:
	void contextMenuEvent ( QContextMenuEvent * event );
};

#endif
