//
// C++ Implementation: spaltenhaefigkeitsdiagramadapter
//
// Description: 
//
//
// Author: Arne Schmitt <arne@as4m.de>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "spaltenhaeufigkeitsdiagramadapter.h"
#include "diagram.h"
#include <QStandardItemModel>
#include <QtDebug>
#include <map>

SpaltenHaeufigkeitsDiagramAdapter::SpaltenHaeufigkeitsDiagramAdapter()
 : ModelMultiDiagramAdapter()
{
}


SpaltenHaeufigkeitsDiagramAdapter::~SpaltenHaeufigkeitsDiagramAdapter()
{
}


void SpaltenHaeufigkeitsDiagramAdapter::updateDiagram()
{
	if(!td || !_model) return;
	using namespace std;

	map<QString,int> he;
	for(int i=0;i<_model->rowCount();++i)
	{
		QString v;
		int rc=0;
		for(QVector<int>::iterator it = Spalten.begin();it!=Spalten.end();++it)
		{
			if(rc++>0) v += ",";
			v += _model->data(_model->index(i,*it)).toString();
		}
		he[v]++; // Haeufigkeit zaehlen
	}
	
	QVector<double> sdata(he.size());
	QStringList labels;
	int i=0;
	for(map<QString,int>::iterator it=he.begin();it!=he.end();++it,++i)
	{
		labels << (*it).first;
		sdata[i] = (int)(*it).second;
	}
	
	processData(sdata); // Weiterverarbeiten in abgeleiteter Klasse
	
	td->setLabels(labels);
	td->setData(sdata);
}

void SpaltenHaeufigkeitsDiagramAdapter::processData(QVector<double>& d)
{

}
