//
// C++ Implementation: xmasdiagram
//
// Description: 
//
//
// Author: Arne Schmitt <arne@as4m.de>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "xmasdiagram.h"
#include <QPainter>
#include <cmath>

XmasDiagram::XmasDiagram()
 : Diagram()
{
	setFixedSize( 150,280);
}


XmasDiagram::~XmasDiagram()
{
}


void XmasDiagram::paintEvent(QPaintEvent* ev)
{
	 QPainter painter(this);
	 painter.fillRect(rect(),Qt::blue);
	 
	 QPoint points[] = {
		 QPoint(25,230),
		 QPoint(125,230),
		 QPoint(75,30),
		 QPoint(25,230)
	 };
	 painter.setPen(Qt::NoPen);
	 painter.setBrush( Qt::green );
	 painter.drawPolygon( points,4);
	 painter.setBrush( QColor(240,100,0) );
	 
	 painter.drawRect(60,230,30,50); // Stamm
	 painter.setPen(Qt::white);
	 painter.setFont(QFont("Arial", 10));
	 painter.drawText(35,30,"Happy Xmas");
	 
	 QPoint stern[] = {
		 QPoint(0,20),
		 QPoint(10,35),
		 QPoint(0,45),
		 QPoint(10,55),
		 QPoint(15,80),
		 QPoint(20,55),
		 QPoint(30,45),
		 QPoint(25,35),
		 QPoint(30,20),
		 QPoint(20,10),
		 QPoint(10,0),
		 QPoint(5,18)
	 };
	 painter.drawPolygon(stern,12);
	 
	 const int N = 8;
	 const double pi = 3.14159265;
	 const double alpha = 2*pi / N;
	 const double r = 10;
	 const double R = 30;
	 const int cx = 120;
	 const int cy = 60;
	 QPoint stern2[2*N];
	 for(int i = 0; i< N; i++)
	 {
		 int x1 = cx + R*cos(alpha*i);
		 int y1 = cy + R*sin(alpha*i);
		 int x2 = cx + r*cos(alpha/2.0+alpha*i);
		 int y2 = cy + r*sin(alpha/2.0+alpha*i);
		 stern2[2*i].setX(x1);
		 stern2[2*i].setY(y1);
		 stern2[2*i+1].setX(x2);
		 stern2[2*i+1].setY(y2);
		
	 }
	 painter.setBrush(Qt::yellow);
	 painter.setPen(Qt::NoPen);
	 painter.drawPolygon(stern2,2*N);
	 
}

